<?php



//////////////////////////////////////////////////////////////////////////////////////////////
// User List

function homeroom_user_list_header(&$table, $name_pattern, $sort, $order)
{
	global $CFG, $wwwBaseUrl;

	if ($order=='ASC') $order = 'DESC';
	else			   $order = 'ASC';

	$firstname_url = $wwwBaseUrl.'&amp;sort=firstname';
	$lastname_url  = $wwwBaseUrl.'&amp;sort=lastname';

	if ($sort=='firstname') {
		$firstname = '<a href="'.$firstname_url.'&amp;order='.$order.'">'.get_string('firstname').'</a>';
		$lastname  = '<a href="'.$lastname_url.'">'.get_string('lastname').'</a>';
	}
	else {
		$firstname = '<a href="'.$firstname_url.'">'.get_string('firstname').'</a>';
		$lastname  = '<a href="'.$lastname_url.'&amp;order='.$order.'">'.get_string('lastname').'</a>';
	}

	//
	$fullnamehead = homeroom_get_fullnamehead($name_pattern, $firstname, $lastname, '/');

	unset($table->head);
	unset($table->align);
	unset($table->size);
	unset($table->wrap);

	// Header
	$table->head [] = '#';
	$table->align[] = 'right';
	$table->size [] = '20px';
	$table->wrap [] = 'nowrap';

	$table->head [] = '';
	$table->align[] = '';
	$table->size [] = '20px';
	$table->wrap [] = 'nowrap';

	$table->head [] = $fullnamehead;
	$table->align[] = 'left';
	$table->size [] = '140px'; 
	$table->wrap [] = 'nowrap';

	$table->head [] = get_string('courselist', 'homeroom');
	$table->align[] = 'left';
	$table->size [] = '420px'; 
	$table->wrap [] = '';

	return;
}




//
function homeroom_print_user_list($students, $name_pattern, $sort, $order)
{
	global $DB, $OUTPUT, $wwwBaseUrl;
	
	$table = new html_table();
	$linkurl = $wwwBaseUrl.'&amp;action=report&amp;sort=date&amp;order=DESC';

	//
	echo '<br />';
	echo '<div align="center">';
	$i = 0;
	foreach($students as $student) {
		$courselist = homeroom_get_course_list($student, 20);
		if (!empty($courselist)) {
			$i++;
			$pic_options = array('size'=>20, 'link'=>true, 'courseid'=>1, 'alttext'=>true, 'popup'=>true);
			$table->data[$student->id][] = $i;
			$table->data[$student->id][] = $OUTPUT->user_picture($student, $pic_options);
			$table->data[$student->id][] = '<a href="'.$linkurl.'&amp;userid='.$student->id.'">'.$student->name.'</a>';
			//if (substr_count($courselist, ', ')>0) {
			//	$courselist.= ', <a href="'.$wwwBaseUrl.'&amp;userid='.$student->id.'&amp;action=crslist&amp;sort=date&amp;order=DESC">ALL</a>';
			//}
			$courselist.= ', <a href="'.$wwwBaseUrl.'&amp;userid='.$student->id.'&amp;action=crslist&amp;sort=date&amp;order=DESC">ALL</a>';
			$table->data[$student->id][] = $courselist;
			//
			if ($i%DEFAULT_PAGE_SIZE==0) {
				homeroom_user_list_header($table, $name_pattern, $sort, $order);
				echo '<div style="margin: 0px 0px 0px 10px;"">';
				echo html_writer::table($table);
				echo '</div>';
				unset($table->data);
			}
		}
	}

	if ($i%DEFAULT_PAGE_SIZE!=0 or $i==0) {
		homeroom_user_list_header($table, $name_pattern, $sort, $order);
		echo '<div style="margin: 0px 0px 0px 10px;"">';
		echo html_writer::table($table);
		echo '</div>';
	}
	//
	echo '</div>';
	echo '<br />';

	return;
}



